// Korea Scientifics, Inc. Yellow Cat Arduino Car Motor Test

const int motorLeftF =11; // 왼쪽 모터의 전진 신호는 11번으로 정의
const int motorLeftB =10; // 왼쪽 모터의 후진 신호는 10번으로 정의
const int motorRightF=6; // 오른쪽 모터의 전진 신호는 6번으로 정의
const int motorRightB=9; // 오른쪽 모터의 전진 신호는 9번으로 정의

void setup() {
	pinMode(motorLeftF, OUTPUT);
	pinMode(motorLeftB, OUTPUT);
	pinMode(motorRightF, OUTPUT);
	pinMode(motorRightB, OUTPUT);
	
	int duration =3000; 
 	left(255); right(0); //왼쪽 바퀴만 전진
 	delay(duration);
 	left(0); right(0);   //정지
 	delay(500);
 	
 	left(0); right(255); //오른쪽 바퀴만 전진
 	delay(duration);
 	left(0); right(0);  //정지
 	delay(500);
 	
 	left(255); right(-255);  //제자리에서 오른쪽으로 회전(왼쪽 모터 전진, 오른쪽 모터 후진)
 	delay(duration);
 	left(0); right(0);  // 정지
 	delay(500);
 	
  	left(-255); right(255);  //제자리에서 왼쪽으로 회전(왼쪽 모터 후진, 오른쪽 모터 전진)
 	delay(duration);
 	left(0); right(0);  //정지
 	delay(500);
}

void loop() {}

void left(int speed){ //왼쪽 모터 제어 
	if (speed >= 0) { //전진
		digitalWrite(motorLeftB, LOW); //왼쪽 후진 신호 OFF
		analogWrite(motorLeftF, speed); //전진 신호 speed의 세기로 회전
	} else { //후진인 경우
		digitalWrite(motorLeftF, LOW); //왼쪽 후진 신호 OFF
		analogWrite(motorLeftB, -speed); //후진 신호 양수로 변경된 speed의 세기로 회전
	}
}
void right(int speed){ //오른쪽 모터 제어 
	if (speed >= 0) { //전진
		digitalWrite(motorRightB, LOW); //오른쪽 후진 신호 OFF
		analogWrite(motorRightF, speed); //전진 신호 speed의 세기로 회전 
	} else { //후진인 경우
		digitalWrite(motorRightF, LOW); //오른쪽 전진 신호 OFF
		analogWrite(motorRightB, -speed); //후진 신호 양수로 변경된 speed의 세기로 회전
	}
}
